﻿using PAT.Common.Classes.Assertion;
using PAT.Common.Classes.LTS;
using PAT.SCSP.LTS;

namespace PAT.SCSP.Assertions{
    public class SCSPAssertionDeadLock : AssertionDeadLock
    {
        private DefinitionRef Process;
        public SCSPAssertionDeadLock(DefinitionRef processDef) : base()
        {
            Process = processDef;
        }

        public SCSPAssertionDeadLock(DefinitionRef processDef, bool isNontermination) : base(isNontermination)
        {
            Process = processDef;
        }

        public override void Initialize(SpecificationBase spec)
        {
            Assertion.Initialize(this, Process, spec);
        }

        public override string StartingProcess
        {
            get
            {
                return Process.ToString();
            }
        }
        
        //todo: override ToString method if your assertion uses different syntax as PAT
        //public override string ToString()
        //{
        //		return "";
        //}
    }
}